/* 
  extra routines
  for now, develop independently of library files.

  later will need to make them integrated methods
*/


#ifndef __EXTRA_POLY_H
#define __EXTRA_POLY_H

/* to convert from new back to old */

#define LeVect vector 
#define polyedre lib_polyhedron 

#define Copy copy
#define Intersection intersection
#define ConvexHull hull
#define AddElt add_elt
#define SuppressColumn  delete_variable 
#define VarAssign var_assign
#define Normalize minimize

const int NFORM = 0;
const int NPLUS1_FORM = 1;



extern int PrtMod;








// void CopyColumn(polyedre *pp4, int i2, int i3);
polyedre * Resize(polyedre *pp4, int newsize);
polyedre * AddAFreeVariable(polyedre *pp4);
// lib_polyhedron * copy_extra_to_old(lib_polyhedron *pp4, int nr_keep_cols, 
//  			       int nr_copy_cols, int *index_p);
lib_polyhedron * delete_cols(lib_polyhedron *pp4, int nr_orig_cols,  int nr_del_vars);
extern int varnr_2_indexnr( int varnr);

// extern lib_polyhedron *lib_polyhedron::vaporize_variable(int v);

extern vector **Exist_vectors;
                         // vcount: the number of global variables
                         // max_ass_vars: max # variables ever reassigned
void make_exist_vectors(int vcount, int max_ass_vars);  

// pretty print the lib_polyhedron using names in varnames
// global var var_count determines number of variables.
void pretty_print(lib_polyhedron *p, char **varnames);


/* new routines for checking whether a frame matrix is OK for addition of */
/* generators */
/* this test must be done before adding generating rays to a region */
/* OK scenarios */
/* 1) bounded. add rays for each frame pt */
/* 2) a cone, i.e. frame representation is only rays. add each ray */
/* 3) includes the origin (plus other pts), add all pts and rays as rays */
/* 4) more generally, if cone through the pts contains all the rays, just */
/*      add rays for all the pts */
/* if any of the above conditions are satisfied, it suffices to merely add */
/*    all elts of the frame as rays */
/* input is a frame in matrix representation */
Bool ok_to_generate(lib_polyhedron *slope_poly) ;

/* new class for nonstrict matrices */

// an n+1 form matrix which represents a non-strict matrix, and therefore
// does not need the 0<=eps<=1 constraints.

class ns_matrix : public matrix {
public:
  // simply inherit everything from the potentially strict matrix for now.
  // difference appears in methods that use ns_matrix and matrix in their 
  // arguments, e.g. opoly->intersection
};


#endif





